#ifndef __HOOKKEYHOOK_H_
#define __HOOKKEYHOOK_H_

/* Defines */
#define HKH_HOOK_ONHOOK		0x00000001
#define HKH_HOOK_OFFHOOK	0x00000002
#define HKH_HOOK_SLIDEOPEN	0x00000004
#define HKH_HOOK_SLIDECLOSE	0x00000008

/* Typedefs */
typedef void (WINAPI * HKH_HOOKPROC)(DWORD dwAction, void* pData);

typedef struct _HKH_PATCHPROCESSINFO {
	DWORD		dwProcessId;
	LPBYTE		pBaseAddr;
	DWORD		dwBaseSize;
	DWORD		dwOnHookOffset;
	DWORD		dwOffHookOffset;
	DWORD		dwSlideOpenOffset;
	DWORD		dwSlideCloseOffset;
	BOOL		bPatched;
} HKH_PATCHPROCESSINFO;


/* Classes */
class CHookKeyHook  
{
public:
	CHookKeyHook();
	virtual ~CHookKeyHook();

	BOOL StartHook(DWORD dwFlag, HKH_HOOKPROC pfnHookProc, void* pData);
	BOOL StopHook();

	static void OnHook();
	static void OffHook();

	friend DWORD WINAPI HookKeyWatchThread(void* pParam);

private:
	BOOL	m_bStopRequest;
	HANDLE	m_hStopEvent;
	HANDLE	m_hThread;

	HANDLE	m_hNewOnHookEvent;
	HANDLE	m_hNewOffHookEvent;
	HANDLE	m_hNewSlideOpenEvent;
	HANDLE	m_hNewSlideCloseEvent;

	HKH_HOOKPROC	m_pfnHookProc;
	void*			m_pUserData;

	DWORD					m_dwFlag;
	HKH_PATCHPROCESSINFO	m_PatchProcessInfo;
};

#endif
